import _ from 'lodash';

class ServiceManager {
  constructor() {
    this.data = [];
  }

  setServices(services = []) {
    if (!Array.isArray(services)) {
      throw new Error('Services is invalid!');
    }
    _.forEach(services, (name, service) => {
      this.setService(name, service);
    });
    return this;
  }

  setService(name, serivce = null) {
    this.data[name] = serivce;
    return this;
  }

  getService(name) {
    return this.data[name];
  }

  getServices() {
    return this.data;
  }

  hasService(name) {
    return Boolean(typeof this.data[name] !== undefined);
  }

  static get(name) {
    return this.getInstance().getService(name);
  }

  static set(name, service) {
    this.getInstance().setService(name, service);
  }

  static getInstance() {
    if (!ServiceManager._singleton) {
      ServiceManager._singleton = new ServiceManager();
    }
    return ServiceManager._singleton;
  }
}
export default ServiceManager;
