import requireAll from 'require-all';
import _ from 'lodash';
import ServiceManager from '../../classes/ServiceManager';

const ConfigLoaderMiddleWare = function (req, res, next) {
  const sm = ServiceManager.getInstance();
  let config = sm.getService('Config');
  const result = requireAll({
    dirname: config.path,
    filter: (filename) => {
      if (filename.indexOf(config.config_ext) !== -1) {
        return filename;
      }
      return;
    },
    excludeDirs: config.exclude_dirs,
    recursive: true,
  });
  if (result.global) {
    _.forEach(result.global, (item) => {
      config = _.merge(config, item.default);
    });
  }
  if (result.local) {
    _.forEach(result.local, (item) => {
      config = _.merge(config, item.default);
    });
  }
  sm.setService('Config', config);
  next();
};
export default ConfigLoaderMiddleWare;
