import {
  GraphQLObjectType,
  GraphQLString,
  GraphQLInt,
  GraphQLList
} from 'graphql';
import CategoryType from '../CategoryType';
import CategoryRepository from '../../services/Category/CategoryRepository';

const PostType = new GraphQLObjectType({
  name: 'Post',
  description: 'Represents a Post',
  fields: () => ({
    id: {
      type: GraphQLInt,
      description: 'The post ID',
      resolve: obj => obj.id
    },
    title: {
      type: GraphQLString,
      description: 'The title of this Post',
      resolve: obj => obj.title,
    },
    content: {
      type: GraphQLString,
      description: 'The title of this Post',
      resolve: obj => obj.content,
    },
    categories: {
      type: new GraphQLList(CategoryType),
      description: 'The categoriess post',
      resolve: obj => CategoryRepository.getCategories(obj.cat_ids)
    }
  }),
});
export default PostType;
