import {
  GraphQLObjectType,
  GraphQLInt
} from 'graphql';

import PostType from '../PostType';
import PostRepository from '../../services/Post/PostRepository';

const Query = new GraphQLObjectType({
  name: 'Query',
  description: 'Root Query',
  fields: () => ({
    query: {
      type: Query,
      resolve: (...args) => args
    },
    post: {
      type: PostType,
      args: {
        id: {
          type: GraphQLInt
        }
      },
      resolve: (obj, { id }) => PostRepository.getPost(id),
    }
  })

});

export default Query;
